Hardware Locality (hwloc): Finding Objects covering at least CPU set

Hardware Locality (hwloc) 2.11.2

Functions
Finding Objects covering at least CPU set

## Functions
static hwloc_obj_t | hwloc_get_child_covering_cpuset (hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_t parent)
static hwloc_obj_t | hwloc_get_obj_covering_cpuset (hwloc_topology_t topology, hwloc_const_cpuset_t set)
static hwloc_obj_t | hwloc_get_next_obj_covering_cpuset_by_depth (hwloc_topology_t topology, hwloc_const_cpuset_t set, int depth, hwloc_obj_t prev)
static hwloc_obj_t | hwloc_get_next_obj_covering_cpuset_by_type (hwloc_topology_t topology, hwloc_const_cpuset_t set, hwloc_obj_type_t type, hwloc_obj_t prev)

## Detailed Description

## Function Documentation

## ◆ hwloc_get_child_covering_cpuset()

static hwloc_obj_t hwloc_get_child_covering_cpuset | ( | hwloc_topology_t | topology,
|  | hwloc_const_cpuset_t | set,
|  | hwloc_obj_t | parent
| ) |  |
| inlinestatic

Get the child covering at least CPU set `set`.

Returns
  the child that covers the set entirely.
  `NULL` if no child matches or if `set` is empty.

Note
  This function cannot work if parent does not have a CPU set (I/O or Misc objects).

## ◆ hwloc_get_next_obj_covering_cpuset_by_depth()

static hwloc_obj_t hwloc_get_next_obj_covering_cpuset_by_depth | ( | hwloc_topology_t | topology,
|  | hwloc_const_cpuset_t | set,
|  | int | depth,
|  | hwloc_obj_t | prev
| ) |  |
| inlinestatic

Iterate through same-depth objects covering at least CPU set `set`.

The next invokation should pass the previous return value in `prev` so as to obtain the next object covering at least another part of `set`.

Returns
  the first object at depth `depth` covering at least part of CPU set `set` if object `prev` is `NULL`.
  the next one if `prev` is not `NULL`.
  `NULL` if there is no next object.

Note
  This function cannot work if objects at the given depth do not have CPU sets (I/O or Misc objects).

## ◆ hwloc_get_next_obj_covering_cpuset_by_type()

static hwloc_obj_t hwloc_get_next_obj_covering_cpuset_by_type | ( | hwloc_topology_t | topology,
|  | hwloc_const_cpuset_t | set,
|  | hwloc_obj_type_t | type,
|  | hwloc_obj_t | prev
| ) |  |
| inlinestatic

Iterate through same-type objects covering at least CPU set `set`.

The next invokation should pass the previous return value in `prev` so as to obtain the next object of type `type` covering at least another part of `set`.

Returns
  the first object of type `type` covering at least part of CPU set `set` if object `prev` is `NULL`.
  the next one if `prev` is not `NULL`.
  `NULL` if there is no next object.
  `NULL` if there is no depth for the given type.
  `NULL` if there are multiple depths for the given type, the caller should fallback to hwloc_get_next_obj_covering_cpuset_by_depth().

Note
  This function cannot work if objects of the given type do not have CPU sets (I/O or Misc objects).

## ◆ hwloc_get_obj_covering_cpuset()

static hwloc_obj_t hwloc_get_obj_covering_cpuset | ( | hwloc_topology_t | topology,
|  | hwloc_const_cpuset_t | set
| ) |  |
| inlinestatic

Get the lowest object covering at least CPU set `set`.

Returns
  the lowest object covering the set entirely.
  `NULL` if no object matches or if `set` is empty.